<?php
/**
 * Server Konfiguration Ueberpruefen
 *
 * LICENSE: $Licensetext:$
 *
 * @category   check
 * @package    NG
 * @author     Stephan Küthe <sk@onsite.org>
 * @author     Michael Lämmlein <ml@onsite.org>
 * @copyright  2009 onSite.org
 * @license    $Licenselink:$  $Licensename:$
 * @version    $Id: check_server.php 3114 2014-09-18 11:37:55Z  $
 */

/**
 * Objekt instanzieren
 */
$obj = CheckServer::getInstance();

?><!doctype html>
<html>
<head>
<meta charset="utf-8" />
<title>check server config</title>
<style type="text/css">
<!--
.ok {
	background-color: #093;
}

.nok {
	background-color: #F33;
}

.noStatus {
	background-color: #CCC;
}

.opt {
	background-color: #FC3;
}

body {
	font-family: Verdana, Geneva, sans-serif;
	font-size: 100%;
	margin: 0px;
	padding: 25px;
}

table {
	border-collapse: collapse;
}

table th {
	background-color: #FC3;
	padding: 5px;
	border-top-width: 1px;
	border-right-width: 1px;
	border-bottom-width: 2px;
	border-left-width: 1px;
	border-top-style: solid;
	border-right-style: solid;
	border-bottom-style: solid;
	border-left-style: solid;
	border-top-color: #FC3;
	border-right-color: #FC3;
	border-bottom-color: #666;
	border-left-color: #FC3;
}

table td {
	border: 1px dotted #CCC;
	padding: 5px;
}

-->
</style>
</head>

<body>
<h2>System requirements</h2>
<table>
	<tr>
		<th>value</th>
		<th>condition</th>
		<th>system</th>
		<th>status</th>
  </tr>
  <?php while($obj->listValues()) { ?>
  <tr>
		<td><?php echo $obj->getName(); ?></td>
		<td><?php echo $obj->getCondition(); ?></td>
		<td><?php echo $obj->getSystem(); ?></td>
		<td class="<?php echo $obj->getStatus(); ?>">&nbsp;</td>
  </tr>
  <?php } ?>
</table>
<br />
<table>
  <tr>
    <td class="ok"></td>
	<td>ok</td>
    <td class="nok"></td>
	<td>not ok</td>
    <td class="opt"></td>
	<td>optional</td>
    <td class="noStatus"></td>
	<td>unascertainable</td>
  </tr>
</table>
<h2>Server Infos</h2>
<table>
  <tr>
    <th>DOCUMENT_ROOT</th>
    <td><?php echo $obj->getDocumentRoot(); ?></td>
  </tr>
  <tr>
    <th>URL_HTTP</th>
    <td><?php echo $obj->getUrlHttp(); ?></td>
  </tr>
  <tr>
    <th>PATH_INSTALL</th>
    <td><?php echo $obj->PathInstall(); ?></td>
  </tr>
</table>

</body>
</html>
<?php
/**
 * Klasse fuer Servercheck
 */
class CheckServer
{
	private	$arr_values = array ();
	private	$next_value = array ();
	private	$str_loaded_extensions = '';
	
	private static $obj_instance = null;

	/**
	 * Konstruktor
	 */
	private function __construct()
	{
//		echo "<pre>";
//		print_r(get_loaded_extensions());
//		echo "</pre>";
		
		$this->str_loaded_extensions = implode('|',get_loaded_extensions());
		
		$this->arr_values = array(
					array(
						"name"			=> "php",
						"user_method"	=> "phpVersion",
						"condition"		=> "5.3.23"),
					array(
						"name"			=> "mysql",
						"user_method"	=> "mysqlVersion",
						"condition"		=> "5.0" ),
					array(
						"name"			=> "register_globals",
						"user_method"	=> "iniValue",
						"condition"		=> false),
					array(
						"name"			=> "memory_limit",
						"user_method"	=> "iniValueCompare",
						"condition"		=> '32M'),
					array(
						"name"			=> "mod_rewrite",
						"user_method"	=> "apacheModule",
						"condition"		=> "loaded"),
					array(
						"name"			=> "mcrypt",
						"user_method"	=> "phpExtension",
						"condition"		=> "loaded"),
					array(
						"name"			=> "mbstring",
						"user_method"	=> "phpExtension",
						"condition"		=> "loaded"),
					array(
						"name"			=> "dom",
						"user_method"	=> "phpExtension",
						"condition"		=> "loaded"),
					array(
						"name"			=> "gd",
						"user_method"	=> "phpExtension",
						"condition"		=> "loaded"),
					array(
						"name"			=> "zlib",
						"user_method"	=> "phpExtension",
						"condition"		=> "loaded"),
					array(
						"name"			=> "zip",
						"user_method"	=> "phpExtension",
						"condition"		=> "loaded"),
					array(
						"name"			=> "soap",
						"user_method"	=> "phpExtension",
						"condition"		=> "loaded",
						"optional"		=> true),
//					array(
//						"name"			=> "Zend Optimizer",
//						"user_method"	=> "phpExtension",
//						"condition"		=> "loaded"),
					array(
						"name"			=> "ionCube Loader",
						"user_method"	=> "phpExtension",
						"condition"		=> "loaded"),
//					array(
//						"name"			=> "ImageMagick",
//						"user_method"	=> "shellTool",
//						"condition"		=> '5.0',
//						"optional"		=> true),
					array(
						"name"			=> "disable_functions",
						"user_method"	=> "iniValue",
						"condition"		=> false,
						"optional"		=> true),
					array(
						"name"			=> "zend.ze1_compatibility_mode",
						"user_method"	=> "iniValue",
						"condition"		=> false),
					array(
						"name"			=> "safe_mode",
						"user_method"	=> "iniValue",
						"condition"		=> false),
					array(
						"name"			=> "idn_to_ascii",
						"user_method"	=> "method",
						"condition"		=> 1),
					array(
						"name"			=> "bcadd",
						"user_method"	=> "method",
						"condition"		=> 1),
					);
	}
	
	/**
	 * Klonen nicht zulassen
	 */
	private function __clone() {}
	
	############################################################################
	
	/**
	 * Instanz erstellen
	 *
	 * @return instance
	 */
	public static function getInstance()
	{
		if(is_null(self::$obj_instance)) {
			$class = __CLASS__;
			self::$obj_instance = new $class();
		}
		
		return self::$obj_instance;
	}
	
	############################################################################
	
	/**
	 * Werte auflisten
	 *
	 * @return boolean
	 */
	public function listValues()
	{
		list($key, $val) = each($this->arr_values);

		if($this->next_value = $val) {
			return true;
		}

		return false;
	}
	
	/**
	 * Name ausgeben
	 */
	public function getName()
	{
		return $this->next_value['name'];
	}
	
	/**
	 * Vorraussetung Version abfragen
	 *
	 * @return mixed
	 */
	public function getCondition()
	{
		$str_method = $this->next_value['user_method']."Condition";
		
		return call_user_func(array($this,$str_method));
	}
	
	/**
	 * System Version abfragen
	 *
	 * @return mixed
	 */
	public function getSystem()
	{
		$str_method = $this->next_value ['user_method'] . "System";
		
		return call_user_func(array($this,$str_method));
	}
	
	/**
	 * Status abfragen
	 *
	 * @return string
	 */
	public function getStatus()
	{
		$str_method = $this->next_value['user_method'] . "Status";
		
		$this->next_value['optional'] = isset($this->next_value ['optional']) ? $this->next_value ['optional'] : false;
		
		$mixed_value = call_user_func(array($this,$str_method));
			
		if (true === $mixed_value) {
			return "ok";
		}
		elseif ('noStatus' === $mixed_value) {
			return "noStatus";
		}
		else
		{
			if(true === $this->next_value['optional']) {
				return "opt";
			}
			
			return "nok";
		}
		
	}
	
	############################################################################

	protected function phpExtensionCondition()
	{
		return $this->next_value['condition'];
	}
	
	protected function phpVersionCondition()
	{
		return $this->next_value['condition'];
	}
	
	protected function mysqlVersionCondition()
	{
		return $this->next_value['condition'];
	}
	
	protected function iniValueCondition()
	{
		$str = $this->next_value['condition'];
		
		if(empty($str) || $str == false) {
			$str = "false";
		}
		
		return $str;
	}
	
	protected function iniValueNoCondition()
	{
		$str = $this->next_value['condition'];
		
		if(empty($str) || $str == false) {
			$str = "false";
		}
		
		return $str;
	}
	
	protected function iniValueCompareCondition()
	{		
		return $this->iniValueCondition();
	}
	
	protected function apacheModuleCondition()
	{
		return $this->next_value['condition'];
	}
	
	protected function shellToolCondition()
	{
		$str = $this->next_value['condition'];
		
		if(empty($str) || $str == false) {
			$str = "false";
		}
		
		return $str;
	}
	
	protected function methodCondition()
	{		
		$str = $this->next_value['condition'];
				
		if(empty($str) || $str == false) {
			$str = "false";
		}
		
		return $str;
	}
	
	############################################################################

	protected function phpExtensionSystem()
	{	
		if(preg_match('/'.preg_quote($this->next_value['name']).'/',$this->str_loaded_extensions)) {
			return $this->next_value['condition'];
		} else {
			return "not " . $this->next_value['condition'];
		}
	}
	
	protected function phpVersionSystem()
	{
		return phpversion();
	}
	
	protected function mysqlVersionSystem()
	{
		return mysql_get_client_info();
	}
	
	protected function iniValueSystem()
	{
		$str = ini_get($this->next_value['name']);
		
		if(empty($str) || $str == false) {
			$str = "false";
		}
		
		return $str;
	}
	
	protected function iniValueNoSystem()
	{
		$str = ini_get($this->next_value['name']);
		
		if(empty($str) || $str == false) {
			$str = "false";
		}
		
		return $str;
	}
	
	protected function iniValueCompareSystem()
	{
		return $this->iniValueSystem();
	}
	
	protected function apacheModuleSystem()
	{
		if(function_exists("apache_get_modules"))
		{
			if(in_array($this->next_value['name'], apache_get_modules())) {
				return 'loaded';
			} else {
				return 'not loaded';
			}
		}
		else {
			return 'apache cgi';
		}
	}
	
	protected function shellToolSystem()
	{		
		$arr = array();
		exec("convert ", $arr);
		if(count($arr) == 0) {
			$arr[0] = false;
		}

		if(preg_match("/".$this->next_value['name']." ([\d\.\-]+) /", $arr[0], $matches)) {
			$str = $matches[1];
		} else {
			$str = "not installed";
		}
		
		return $str;
	}
	
	protected function methodSystem()
	{
		if (function_exists($this->next_value['name'])){
			return true;
		}
		else{
			return false;
		}
	}
	
	############################################################################
	
	private function phpExtensionStatus()
	{
		if(preg_match('/'.preg_quote($this->next_value['name']).'/',$this->str_loaded_extensions)) {
			return true;
		}
	}
	
	private function phpVersionStatus()
	{
		if(version_compare(phpversion(), $this->next_value['condition'], ">=")) {
			return true;
		}
	}
	
	private function mysqlVersionStatus()
	{
		if(version_compare(mysql_get_client_info(), $this->next_value['condition'], ">=")) {
			return true;
		}
	}
	
	private function iniValueStatus()
	{
		if($this->next_value['condition'] == ini_get($this->next_value['name'])) {
			return true;
		}
	}
	
	private function iniValueNoStatus()
	{
		$arr1	= array_map("trim",explode(",",ini_get($this->next_value['name'])));
		$arr2	= array_map("trim",explode(",",$this->next_value['condition']));
		
		$arr = array_intersect($arr1, $arr2);
		
		if(0 === count($arr)) {
			return true;
		}
	}
	
	private function iniValueCompareStatus()
	{
		if(version_compare(ini_get($this->next_value['name']), $this->next_value['condition'], ">=")) {
			return true;
		}
	}
	
	private function apacheModuleStatus()
	{
		if(function_exists("apache_get_modules"))
		{
			if(in_array($this->next_value['name'], apache_get_modules())) {
				return true;
			}
		} else {
			return 'noStatus';
		}
	}
	
	private function shellToolStatus()
	{
		$arr = array();
		exec("convert ", $arr);
		if(count($arr) == 0) {
			$arr[0] = false;
		}

		if(preg_match("/".$this->next_value['name']." ([\d\.\-]+) /", $arr[0], $matches)) {
			$str = $matches[1];
		} else {
			$str = "0";
		}
		
		if(version_compare($str, $this->next_value['condition'], ">=")) {
			return true;
		}
	}
	
	private function methodStatus()
	{
		if($this->next_value['condition'] == 1){
			return true;
		}
		else{
			return false;
		}
	}
	
	###########################################################################
	###########################################################################
	
	public function getDocumentRoot()
	{
		return $_SERVER['DOCUMENT_ROOT'];
	}

	public function getUrlHttp()
	{
		if('443' === $_SERVER['SERVER_PORT']) {
			$p = 'https://';
		} else {
			$p = 'http://';
		}
		
		return $p.$_SERVER['HTTP_HOST'];
	}
	
	public function PathInstall()
	{
		$str = preg_replace("#^".preg_quote($_SERVER['DOCUMENT_ROOT'])."(.*)?.check_server\.php$#","$1",$_SERVER['SCRIPT_FILENAME']);
		
		return $str;
	}
	
}
